/* agpFrag.c was originally generated by the autoSql program, which also 
 * generated agpFrag.h and agpFrag.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "agpFrag.h"

void agpFragStaticLoad(char **row, struct agpFrag *ret)
/* Load a row from agpFrag table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
{
int sizeOne,i;
char *s;

ret->chrom = row[0];
ret->chromStart = sqlUnsigned(row[1])-1;
ret->chromEnd = sqlUnsigned(row[2]);
ret->ix = sqlSigned(row[3]);
strcpy(ret->type, row[4]);
ret->frag = row[5];
ret->fragStart = sqlSigned(row[6])-1;
ret->fragEnd = sqlUnsigned(row[7]);
strcpy(ret->strand, row[8]);
}

struct agpFrag *agpFragLoad(char **row)
/* Load a agpFrag from row fetched with select * from agpFrag
 * from database.  Dispose of this with agpFragFree(). */
{
struct agpFrag *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->chromStart = sqlUnsigned(row[1])-1;
ret->chromEnd = sqlUnsigned(row[2]);
ret->ix = sqlSigned(row[3]);
strcpy(ret->type, row[4]);
ret->frag = cloneString(row[5]);
ret->fragStart = sqlUnsigned(row[6])-1;
ret->fragEnd = sqlUnsigned(row[7]);
strcpy(ret->strand, row[8]);
return ret;
}

struct agpFrag *agpFragCommaIn(char **pS, struct agpFrag *ret)
/* Create a agpFrag out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new agpFrag */
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s)-1;
ret->chromEnd = sqlUnsignedComma(&s);
ret->ix = sqlSignedComma(&s);
sqlFixedStringComma(&s, ret->type, sizeof(ret->type));
ret->frag = sqlStringComma(&s);
ret->fragStart = sqlUnsignedComma(&s)-1;
ret->fragEnd = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->strand, sizeof(ret->strand));
*pS = s;
return ret;
}

void agpFragFree(struct agpFrag **pEl)
/* Free a single dynamically allocated agpFrag such as created
 * with agpFragLoad(). */
{
struct agpFrag *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->frag);
freez(pEl);
}

void agpFragFreeList(struct agpFrag **pList)
/* Free a list of dynamically allocated agpFrag's */
{
struct agpFrag *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    agpFragFree(&el);
    }
*pList = NULL;
}

void agpFragOutput(struct agpFrag *el, FILE *f, char sep, char lastSep) 
/* Print out agpFrag.  Separate fields with sep. Follow last field with lastSep. */
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart+1);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
fprintf(f, "%d", el->ix);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->type);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->frag);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->fragStart+1);
fputc(sep,f);
fprintf(f, "%u", el->fragEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->strand);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

